/***************************************************************************

        Auticko - joystick.c

        copyright (C) 2002 by Josef Kufner <jkufner@seznam.cz>


     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

***************************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <linux/joystick.h>

#include "joystick.h"

#define JOYSTICK_DEVICE	"/dev/js0"

JS_STATE js_state = {
	{ 0, 0 },
	{ 0, 0, 0, 0 },
	0, 0,
	-1
};

int joy_Init (void) {
	
	js_state.fd = open(JOYSTICK_DEVICE, O_RDONLY);
	if (js_state.fd == -1) {
		/* Neni joystick */
		js_state.no_axis = -1;
		js_state.no_btns = -1;
		return -1;
	}
	
	/* Zjisteni co je joystick zac */
	if (ioctl(js_state.fd, JSIOCGAXES, &(js_state.no_axis)) == -1)
		return -1;
	if (ioctl(js_state.fd, JSIOCGBUTTONS, &(js_state.no_btns)) == -1)
		return -1;

	return 0;
}

int joy_Get_Event (void) {
	struct js_event joy_e;
	int ret;
	
	/* nacteni dat z joysticku */
	read(js_state.fd, &joy_e, sizeof(struct js_event));
	
	/* dekodovani */
	switch (joy_e.type) {
		case JS_EVENT_AXIS:
			js_state.axis[joy_e.number] = joy_e.value;
			ret = joy_e.number == 0 ? JS_X : JS_Y;
			break;
		case JS_EVENT_BUTTON:
			js_state.btn[joy_e.number] = joy_e.value;
			ret = JS_BTN0 + joy_e.number;		/* Ktere tlacitko (0x1?) */
			ret |= ((~joy_e.value & 1)) << 5;	/* Stisknuto nebo uvolneno */
			break;
		case JS_EVENT_INIT:
			ret = JS_INIT;
			break;
	}
	
	return ret;
}

int joy_Clean_Up (void) {
	close(js_state.fd);
	js_state.no_axis = -1;
	js_state.no_btns = -1;
	return 0;
}

