/***************************************************************************

        Auticko - ui_fn.c

        copyright (C) 2002 by Josef Kufner <jkufner@seznam.cz>


     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

***************************************************************************/

#include <stdlib.h>
#include <ncurses.h>		/* Kvuli definicim klaves KEY_* */

#include "ui_fn.h"
#include "ui.h"
#include "auticko.h"
#include "joystick.h"

#define TOGGLE(x)	x = (x == 0)

UI_FN main_ui[] = {
/*	key, joystick,	fn,		data,	title,		keyname*/
{	' ', 0,		fn_stop,	0,	"Stop",		"space"},
{	KEY_UP, JS_Y,	fn_go,		-1,	"Je Vped",	"Up"},
{	KEY_DOWN, 0,	fn_go,		1,	"Je Zpt",	"Down"},
{	KEY_LEFT, JS_X,	fn_go,		-2,	"Je Vlevo",	"Left"},
{	KEY_RIGHT, 0,	fn_go,		2,	"Je Vpravo",	"Right"},
{	0, 0,		NULL,		0,	"",		""},
{	'h', JS_BTN0,	fn_horn,	0,	"Houkaka",	"h"},
{	'l', JS_BTN1,	fn_light,	0,	"Svtla",	"l"},
{	0, 0,		NULL,		0,	"",		""},
{	'.', JS_BTN3,	fn_blink_right,	0,	"Blinkr vpravo","."},
{	',', JS_BTN2,	fn_blink_left,	0,	"Blinkr vlevo",	","},
{	0, 0,		NULL,		0,	"",		""},
{	'q', 0,		fn_Konec,	0,	"Konec",	"q"},
{	0, 0,		NULL,		0,	NULL,		NULL }
	
}; 

void fn_stop (int arg) {
/*	ui_Terminal(T_OK "Stop.\n"); */
	js_state.axis[1] = 0;

	/* Update obrazku */
	pict_val.up = 0;
	pict_val.down = 0;

	/* Vyslani prikazu */
	Auticko_Send_Command(CMD_STOP, 0);
}

void fn_go (int arg) {

	switch(arg) {
		/* Joystick */
		case 0:
/*			ui_Terminal("Go - joystick: X=%7d Y=%7d \n",
 					js_state.axis[0], js_state.axis[1]);
*/
			break;

		/* Klavesnice -- simuluje nakloneni joysticku */
		case -1:
			js_state.axis[1] = -20000;
		/*	ui_Terminal("Go - Vped.\n"); */
			break;
		case 1:
			js_state.axis[1] = 20000;
/*			ui_Terminal("Go - Zpt\n"); */
			break;
		case -2:
			if (js_state.axis[0] > 1000)
				js_state.axis[0] = 0;
			else
				js_state.axis[0] = -20000;
			
		/*	ui_Terminal(T_ERR "fn_go_left: not implemented\n"); */
/*			Auticko_Send_Command(CMD_LEFT, (unsigned) smer); */
			break;
		case 2:
			if (js_state.axis[0] < -1000)
				js_state.axis[0] = 0;
			else
				js_state.axis[0] = 20000;
			
		/*	ui_Terminal(T_ERR "fn_go_right: not implemented\n"); */
/*			Auticko_Send_Command(CMD_RIGHT, (unsigned) smer); */
			break;
	}

	/* Update obrazku */
	pict_val.up = (js_state.axis[1] < -1000);
	pict_val.down = (js_state.axis[1] > 1000);
	pict_val.left = (js_state.axis[0] < -1000);
	pict_val.right = (js_state.axis[0] > 1000);
	
	/* Vyslani prikazu */
	/* (Staci pouze pro to primitivni auticko) */
	if (js_state.axis[1] < 1000 && js_state.axis[1] > -1000)
		fn_stop(0);
	else
		Auticko_Send_Command(CMD_GO, (js_state.axis[1] < 1000));
}	

void fn_horn (int arg) {
	ui_Terminal(T_ERR "fn_horn: not implemented\n");
}

void fn_light (int arg) {
	TOGGLE(pict_val.light);
	ui_Terminal(T_ERR "fn_light: not implemented\n");
}

void fn_blink_left (int arg) {
	TOGGLE(pict_val.l_blink);
	ui_Terminal(T_ERR "fn_blink_left: not implemented\n");
}

void fn_blink_right (int arg) {
	TOGGLE(pict_val.r_blink);
	ui_Terminal(T_ERR "fn_blink_right: not implemented\n");
}

void fn_Konec (int arg) {
	ui_Terminal("Exit...");
	exit(0);
}

